/* ------------------------------------------------------------------------- *
 * Cavalin Alberto | Matr. 472802 | -------------------------- | 05/mar/2003 *
 * ------------------------------------------------------------------------- */


// [ Librerie delle funzioni di sistema ] ------------------------------------
#include <stdio.h>						//gestione dell'I/O
#include <sys/socket.h>					//gestione delle connessioni socket
#include <unistd.h>						//gestione dei file descriptor
#include <netinet/in.h>					//gestione indirizzi internet
#include <string.h>						//gestione delle stringhe
// ---------------------------------------------------------------------------


// [ Strutture, var enumerative, ecc... ] ------------------------------------
enum BOOL { FALSE, TRUE };              //var booleana

struct sockaddr_in ind;					//var indirizzo per il socket

#define LRISP 60000						//lunghezza massima della risposta
// ---------------------------------------------------------------------------


/* ------------------------------------------------------------------------- *
 * MAIN: Funzione principale                                                 *
 * I : \   | \                                                               *
 * O : int | codice di uscita del programma                                  *
 * ------------------------------------------------------------------------- */
int main() {
	int  s;								//handle del socket
	char *pt;							//pt per gli accessi in memoria
	char req[]="GET /index.html\n";		//richiesta del client
	char risp[LRISP];					//risposta del server
	int  n;								//n char letti

	// [ creazione del socket              ] ---------------------------------
	s=socket(PF_INET,SOCK_STREAM,0);
	if (s==-1) {
		printf("Inizializzazione socket fallita!\n");
		return -1;
	}//if

	// [ inizializzazione socket           ] ---------------------------------
	ind.sin_family=AF_INET;
	ind.sin_port=htons(80);						//porta
	pt=(char *)&ind.sin_addr.s_addr;
	pt[0]=147; pt[1]=162; pt[2]=35; pt[3]=42;	//indirizzo

	// [ connessione                       ] ---------------------------------
	if (connect(s,(struct sockaddr *)&ind,sizeof(struct sockaddr_in))!=0) {
		perror("Connessione fallita");
		return -2;
	}//if

	// [ invio della richiesta             ] ---------------------------------
	if (write(s,req,strlen(req))==-1) {
		perror("Richiesta fallita");
		return -3;
	}//if

	// [ lettura e stampa della risposta   ] ---------------------------------
	while(n=read(s,risp,LRISP-1)) {
		if (n==-1) {
			perror("Lettura fallita");
			return -4;
		}//if
		risp[n]='\0';
		printf("%s\n",risp);
	}//while

	// [ chiusura della connessione        ] ---------------------------------
	close(s);

	// [ programma terminato correttamente ] ---------------------------------
	return 0;
}//main ----------------------------------------------------------------------
