/* ------------------------------------------------------------------------- *
 * Cavalin Alberto | Matr. 472802 | -------------------------- | 06/mar/2003 *
 * ------------------------------------------------------------------------- */


// [ Librerie delle funzioni di sistema ] ------------------------------------
#include <stdio.h>						//gestione dell'I/O
#include <sys/socket.h>					//gestione delle connessioni socket
#include <sys/types.h>					//gestione dei tipi
#include <netinet/in.h>					//gestione indirizzi internet
#include <unistd.h>						//gestione dei file descriptor
// ---------------------------------------------------------------------------


// [ Strutture, var enumerative, ecc... ] ------------------------------------
#define LRISP 50000						//lunghezza massima della risposta

struct sockaddr_in ind,ind_cl;			//var indirizzo per il socket
// ---------------------------------------------------------------------------


/* ------------------------------------------------------------------------- *
 * MAIN: Funzione principale                                                 *
 * I : \   | \                                                               *
 * O : int | codice di uscita del programma                                  *
 * ------------------------------------------------------------------------- */
int main() {
	int  s,s_cl;						//handles del socket
	char risp[LRISP];					//risposta del server
	int  n;								//n char letti
	int ind_cl_size;					//dimensione della struttura

	// [ creazione del socket              ] ---------------------------------
	s=socket(PF_INET,		/*tipo famiglia			*/
			 SOCK_STREAM,	/*tipo protocollo		*/
			 0				/*numero di protocollo	*/
			);
	if (s==-1) {
		perror("Inizializzazione socket fallita");
		return -1;
	}//if

	// [ inizializzazione socket           ] ---------------------------------
	ind.sin_family=AF_INET;
	ind.sin_port=htons(8700);						//porta

	// [ binding                           ] ---------------------------------
	if (bind(s,(struct sockaddr *)&ind,sizeof(struct sockaddr_in))!=0) {
		perror("Bind fallita");
		return -2;
	}//if

	// [ inizio attesa di connessioni      ] ---------------------------------
	if (listen(s,SOMAXCONN)==-1) {
		perror("Listen fallita");
		return -3;
	}//if

	// [ attesa di una connessione in coda ] ---------------------------------
	s_cl=accept(s,(struct sockaddr *)&ind_cl,&ind_cl_size);
	if (s_cl==-1) {
		perror("Accept fallita");
		return -4;
	}//if

	// [ lettura della richiesta           ] ---------------------------------
	while(n=read(s_cl,risp,LRISP-1)) {
		if (n==-1) {
			perror("Lettura fallita");
			return -5;
		}//if
		risp[n]='\0';
		printf("%s",risp);
	}//while

	// [ chiusura della connessione        ] ---------------------------------
	close(s_cl);
	close(s);

	// [ programma terminato correttamente ] ---------------------------------
	return 0;
}//main ----------------------------------------------------------------------

