/* ------------------------------------------------------------------------- *
 * Cavalin Alberto | Matr. 472802 | -------------------------- | 20/mar/2003 *
 * ------------------------------------------------------------------------- */


// [ Librerie delle funzioni di sistema ] ------------------------------------
#include <stdio.h>						//gestione dell'I/O
#include <sys/socket.h>					//gestione delle connessioni socket
#include <sys/types.h>					//gestione dei tipi
#include <netinet/in.h>					//gestione indirizzi internet
#include <unistd.h>						//gestione dei file descriptor
#include <netdb.h>						//funzioni per l'ARP ecc...
#include <string.h>						//manipolazione delle stringhe
// ---------------------------------------------------------------------------


// [ Strutture, var enumerative, ecc... ] ------------------------------------
#define LRISP 50000						//lunghezza massima della risposta

struct sockaddr_in ind,ind_cl,ind_sv;	//var indirizzo per il socket
// ---------------------------------------------------------------------------


/* ------------------------------------------------------------------------- *
 * MAIN: Funzione principale                                                 *
 * I : \   | \                                                               *
 * O : int | codice di uscita del programma                                  *
 * ------------------------------------------------------------------------- */
int main() {
	// [ variabilie usate                  ] ---------------------------------
	int  s,								//socket per la listen
		 s_cl,							//socket per la accept
		 s_sv;							//socket per la connect
	char risp[LRISP];					//risposta del server
	char ask[LRISP];					//richiesta da passare al server
	int  n;								//n char letti
	int  ind_cl_size;					//dimensione della struttura
	char *page;							//puntatore al nome della pagina
	char nome_server[200];				//nome del server
	int  i;								//var contatore
	char *pt;							//pt temporaneo
	FILE *pf;							//pt al file da spedire
	struct hostent *server_he;			//pt alla struttura hostent del server

	// [ socket per la bind                ] ---------------------------------
	s=socket(PF_INET,		/*tipo famiglia			*/
			 SOCK_STREAM,	/*tipo protocollo		*/
			 0				/*numero di protocollo	*/
			);
	if (s==-1) {
		perror("Inizializzazione socket fallita");
		return -1;
	}//if

	// [ inizializzazione socket           ] ---------------------------------
	ind.sin_family=AF_INET;
	ind.sin_port=htons(8700);			//porta

	// [ binding                           ] ---------------------------------
	if (bind(s,(struct sockaddr *)&ind,sizeof(struct sockaddr_in))!=0) {
		perror("Bind fallita");
		return -2;
	}//if

	// [ inizio attesa di connessioni      ] ---------------------------------
	if (listen(s,SOMAXCONN)==-1) {
		perror("Listen fallita");
		return -3;
	}//if

while(1) {

	// [ attesa di una connessione in coda ] ---------------------------------
	s_cl=accept(s,(struct sockaddr *)&ind_cl,&ind_cl_size);
	if (s_cl==-1) {
		perror("Accept fallita");
		return -4;
	}//if

	// [ lettura della richiesta           ] ---------------------------------
	n=read(s_cl,risp,LRISP-1);
	if (n==-1) {
		perror("Lettura fallita");
		return -5;
	}//if
	risp[n]='\0';
	printf("%s",risp); 						//stampa del buffer

	for (i=11;risp[i]!='/';i++)				//estrazione del nome del server
		nome_server[i-11]=risp[i];
	nome_server[i-11]='\0';
	printf("Il nome del server e': %s\n",nome_server);

	page=&risp[i+1];						//estrazione del nome della pagina
	for (i=0;page[i]!=' ';i++) ;
	page[i]='\0';
	printf("Il nome del file e': %s\n",page);

	server_he=gethostbyname(nome_server);	//risoluzione dell'indirizzo
	printf("Indirizzo del server: %d.%d.%d.%d\n",
			(unsigned char)(server_he->h_addr[0]),
			(unsigned char)(server_he->h_addr[1]),
			(unsigned char)(server_he->h_addr[2]),
			(unsigned char)(server_he->h_addr[3])
		   );

	// [ socket per la connect al server   ] ---------------------------------
	s_sv=socket(PF_INET,SOCK_STREAM,0);
	ind_sv.sin_family=AF_INET;
	ind_sv.sin_port=htons(80);
	pt=(char *)&ind_sv.sin_addr.s_addr;
	pt[0]=(*server_he).h_addr[0];
	pt[1]=(*server_he).h_addr[1];
	pt[2]=(*server_he).h_addr[2];
	pt[3]=(*server_he).h_addr[3];
	if (connect(s_sv,(struct sockaddr *)&ind_sv,sizeof(struct sockaddr_in))!=0) {
		perror("Connessione al server fallita");
		//return -6;
		sprintf(risp,"<html><body>Richiesta fallita!</body></html>");
		if (write(s_cl,risp,strlen(risp))<0) {
			perror("Risposta fallita");
			return -9;
		}//if
		continue;
	}//if

	// [ invio della richiesta al server   ] ---------------------------------
	sprintf(ask,"GET /%s\n\n",page);
	if (write(s_sv,ask,strlen(ask))<0) {
		perror("Richiesta fallita");
		return -7;
	}//if

	// [ lettura/invio della risposta      ] ---------------------------------
	while(n=read(s_sv,risp,LRISP-1)) {
		if (n==-1) {
			perror("Lettura fallita");
			return -8;
		}//if
		risp[n]='\0';
		if (write(s_cl,risp,n)<0) {
			perror("Risposta fallita");
			return -9;
		}//if
	}//while


	// [ chiusura delle connessioni        ] ---------------------------------
	shutdown(s_sv,SHUT_RDWR);
	shutdown(s_cl,SHUT_RDWR);
	close(s_sv);
	close(s_cl);

}//while

	// [ chiusura della connessione        ] ---------------------------------
	shutdown(s,SHUT_RDWR);
	close(s);

	// [ programma terminato correttamente ] ---------------------------------
	return 0;
}//main ----------------------------------------------------------------------

