/**********************************************/
/**Programma di routing---> a due reti LAN*****/
/**********************************************/

#include <sys/socket.h>
#include <features.h>    /* for the glibc version number */
#if __GLIBC__ >= 2 && __GLIBC_MINOR >= 1
#include <netpacket/packet.h>
#include <net/ethernet.h>     /* the L2 protocols */      
#else
#include <asm/types.h>
#include <linux/if_packet.h>
#include <linux/if_ether.h>   /* The L2 protocols */       
#endif

struct icmp
{
	unsigned char type;
	unsigned char code;
	unsigned short check;
	unsigned short ident;
	unsigned short sn;	
	unsigned char data;
};

struct decis {						//Elemento di decisione: a)IP destinazione b)Interfaccia di rete
	unsigned int to;
	int ifn;
	};
	
struct route_entry					//2 rotte possibili interfaccia della I rete o II rete
	{						//Decione presa dalla subnetmask dell'IP di rete
	unsigned int dst;
	unsigned int msk;
	unsigned int nxt;
	unsigned int ifn;
	};
struct route_entry rt[2]={ {0x0001010a,0x00ffffff,0,3}, 
			   {0x0023a293,0x00ffffff,0,2}};
int rt_n=2;
							//IP e MAC delle reti e delle schede di rete
unsigned char mymac[2][6] = { {0x00,0x01,0x02,0x1e,0x68,0x37},{0x00,0x50,0xda,0x7c,0xbc,0xe4}};
unsigned char myip[2][4] = { { 147, 162,35,137},{10,1,1,1}};
unsigned short fair_port[10] = {8120, 8121, 80, 6863, 3851, 4, 1566, 238, 111, 8129};

struct arp_entry
{
	unsigned char mac[6];
	unsigned char ip[4];
	unsigned int cont;
};

struct arp_entry arp_t[256];				//Cache con IP e rispettivi MAC (da aggiornare)
int arp_n=0;

#define ETH_SIZE 1500
struct sockaddr_ll from;				//Pacchetto di ricezione qualunque esso sia
struct arp_packet{					//Formato pacchetto ARP ( associa ad IP l'ind macchima )
	short hwtype;
	short prottype;
	char hwsize;
	char protsize;
	short op;
	char sender_ha[6];
	char sender_pa[4];
	char receiver_ha[6];
	char receiver_pa[4];
	};
struct statistica					//Dichiarazione di una struttura per fornire statistiche 
{
	unsigned int totale;
	unsigned int sender1;
	unsigned int sender2;
	unsigned int receiver1;
	unsigned int receiver2;
	unsigned int anonimo;
};
struct statistica statistiche;			



void stampa_ARP()					//Stampa un new MAC trovato non presente nella cache
{
int i;
for(i=0;i<arp_n;i++)
	printf("%d.%d.%d.%d -----> %x:%x:%x:%x:%x:%x\n",arp_t[i].ip[0],arp_t[i].ip[1],arp_t[i].ip[2],arp_t[i].ip[3],arp_t[i].mac[0],arp_t[i].mac[1],arp_t[i].mac[2],arp_t[i].mac[3],arp_t[i].mac[4],arp_t[i].mac[5]);
printf("==========\n\n");
}

int aggiorna_ARP(char* mac, char *ip)			//Aggiorna o inserisce nella cache i MAC add per ciascuno IP
{
int i;
for(i=0;i<arp_n;i++) {
	if ( memcmp(ip,arp_t[i].ip,4) == 0){ /* Se sono uguali*/
		memcpy(arp_t[i].mac,mac,6);  /* Aggiorno la entry*/	
		return 1;
	}
}
memcpy(arp_t[arp_n].mac,mac,6); /* Aggiungo la entry mac*/	
memcpy(arp_t[arp_n].ip,ip,4);   /* Aggiungo la entry ip*/	
arp_t[arp_n].cont=1;		/* Inizializza il contatore per le statistiche */
arp_n ++; 
return 0;
}

int decidi(unsigned char * buffer, struct decis *d)	//Verifica il datagram che sia ind ad una o l'altra rete
{							//Aggiorna i campi di destinazione per ind nell'iterfaccia opportuna
int i, trovato=0;
unsigned int * dst, * source; 
dst = ((unsigned int *) buffer) + 4;
source = ((unsigned int *) buffer) + 3;
for(i=0;i<rt_n && ! trovato;i++){
	if( (*dst & rt[i].msk) == (rt[i].dst & rt[i].msk))
	{
		trovato = 1;
		if ( rt[i].nxt == 0 )
			(*d).to = *dst;
		else 		
			(*d).to = rt[i].nxt;
		(*d).ifn = rt[i].ifn;
		if(i==0)
			statistiche.sender1++;
		else
			statistiche.sender2++;
	}
	if( (*source & rt[i].msk) == (rt[i].dst & rt[i].msk))
		if(i==0)
			statistiche.receiver1++;
		else
			statistiche.receiver2++;
}
if ( trovato ) 
	printf("Ho deciso per %d.%d.%d.%d\n",*((unsigned char *) dst),*((unsigned char *) dst+1),*((unsigned char *)dst+2),*((unsigned char *)dst+3));
if (! trovato ){
	printf("Non so come raggiungere %d.%d.%d.%d\n",*((unsigned char *) dst),*((unsigned char *) dst+1),*((unsigned char *)dst+2),*((unsigned char *)dst+3));
	statistiche.anonimo++;
}
return trovato;
} 

int ricevi(int s, char * buffer, int * lungh_pacc,short checksum)	//Ricevuto un pacchetto ARP o IP lo riconosce  
{							//Aggiorna la cache IP---->MAC
int i;
int s0;
int len;
int from_len;
struct arp_packet *arp_p;
struct icmp echo;
//char ihl, * pc, c;
from.sll_family = AF_PACKET; from.sll_protocol = htons(ETH_P_ALL); from.sll_ifindex =0; from.sll_pkttype = 0; from.sll_hatype=0; from.sll_halen=0;
from_len = sizeof(struct sockaddr_ll);
len = recvfrom(s,buffer,ETH_SIZE,0,(struct sockaddr*)&from,&from_len);
*lungh_pacc = len;

echo.type=buffer[25];
echo.code=0;
echo.check=checksum;
echo.ident=0;
echo.sn=0;	
echo.data=htons(0x01);



if ( len == -1 ){
	perror("recvfrom fallita");
	return 1;
	}
if (from.sll_protocol == htons(0x0806)){
	arp_p = (struct arp_packet *) buffer;	
	if(aggiorna_ARP((*arp_p).sender_ha, (*arp_p).sender_pa) == 0)
		stampa_ARP();
	return 1;
	}

if (from.sll_protocol == htons(0x0800)){
	//printf("Ho ricevuto un pacchetto IP\n"); 
	statistiche.totale++;
	if(buffer[9]==1)
	{
		printf("Il pacchetto ricevuto  ICMP\n");
		for(i=0;i<4;i++)
		printf("IP: %d\n", *(unsigned char *)&buffer[16+i]);
			}		
  return 0;
}

for(i=0;i<len;i++){
	printf("%x ",buffer[i]);
	}
printf("\n");

return 1;
}	
int trova_arp(unsigned int ip, unsigned char *mac) 	//Dato un IP verifica e salva un MAC add se lo trova in cache 
{
int i;
for (i=0;i<arp_n;i++){
	if ( memcmp(&ip,arp_t[i].ip,4) == 0 ){
		memcpy(mac,arp_t[i].mac,6);
		arp_t[i].cont++;
		return 1; 
	}
}
return 0;
}

void invia_arp(int s0, struct decis d)			//Prepara un pacchetto ARP con IP e MAC source e scatena l'inferno
{
struct sockaddr_ll to;
struct arp_packet ap;
to.sll_family = AF_PACKET;
to.sll_protocol = htons (ETH_P_ARP);
to.sll_ifindex = d.ifn;
to.sll_addr[0]=255; to.sll_addr[1]=255; to.sll_addr[2]=255; to.sll_addr[3]=255; to.sll_addr[4]=255; to.sll_addr[5]=255; 
ap.hwtype = htons(1);
ap.prottype = htons (0x0800);
ap.hwsize = 6;
ap.protsize = 4;
ap.op = htons(1);
memcpy(ap.sender_ha,mymac[d.ifn-2],6);
memcpy(ap.sender_pa,myip[d.ifn-2],4);
ap.receiver_ha[0]=0; ap.receiver_ha[1]=0; ap.receiver_ha[2]=0; ap.receiver_ha[3]=0; ap.receiver_ha[4]=0; ap.receiver_ha[5]=0;
memcpy(ap.receiver_pa,&d.to,4);
if (sendto(s0,(unsigned char *)&ap,sizeof(ap),0,(struct sockaddr *)&to,sizeof(to))== -1){
	perror("Invio pacchetto ETH+ARP fallito");
	}

}

void invia(int s0, unsigned char * buffer, int pktlen, struct decis d, short checksum)  //Recupera il MAC e invia il pacchetto  completo
{
struct sockaddr_ll to;
unsigned char mac[6];
struct icmp echo;
char uno=1;

 if (trova_arp(d.to,mac) == 0){
	invia_arp(s0,d);
	return ;
 }
 to.sll_family = AF_PACKET; 
 to.sll_protocol=htons(ETH_P_IP);
 to.sll_halen = 6;  
 to.sll_ifindex = d.ifn;
echo.type=buffer[25];
echo.code=0;
echo.check=checksum;
echo.ident=0;
echo.sn=0;	
echo.data=htons(0x01); 
 memcpy((unsigned char *)&buffer[7],(unsigned char *)&uno,1);
 memcpy(to.sll_addr,mac,6);
 if(echo.type==8)
 printf("Ho fatto un invio ICMP ECHO"); 
 if (sendto(s0,buffer,pktlen,0,(struct sockaddr *)&to,sizeof(to))== -1){
	perror("Invio pacchetto IP+ICMP fallito");
	}
 } 



unsigned short checksum(unsigned short * seq, int lungh)
{
int i;
unsigned short oldcs, cs=0;
for(i=0; i<lungh;i++)
	{
	oldcs=cs;
	cs=cs+seq[i];
	if(cs<oldcs)
	cs++;
	}	
cs=0xfff-cs;
return cs;
} 

 

int main()
{
unsigned char buffer[1500], c;
int s0;
int n, cont=300, i;
int pkt_len;
short checksum;
float stat;
struct decis decisione;
statistiche.totale = 0;					//Inizializzazione struttura statistiche;
statistiche.sender1 = 0;
statistiche.sender2 = 0;
statistiche.receiver1 = 0;
statistiche.receiver2 = 0;
statistiche.anonimo = 0;


s0=socket(PF_PACKET, SOCK_DGRAM, htons(ETH_P_ALL) );  //Apertura di un PoA per la ricezione tutti i protocolli di rete
if (s0 == -1 ){
	perror("socket fallita");
	return 1;
	}
while( cont > 0 ) {
	n=ricevi(s0,buffer,&pkt_len,checksum);               //Riceve un pacchetto lo riconosce e aggiorna la cache
	if (n == 0){				      	    //Se trattasi di un pacchetto IP:
		if (decidi(buffer, &decisione)==1)    	    //Decide l' interface di rete da indirizzarlo
			invia(s0,buffer,pkt_len,decisione,checksum); //Se l'interface e conosciuta invia il pacchetto a destination
		}
	cont--;
	if( cont == 1) {
		printf("\n::::::::::::::::STATISTICHE DELLA RETE::::::::::::::::::::\n");
		printf("Pacchetti provenienti dalla prima interfaccia(rete1):  %d\n", statistiche.receiver1);
		printf("Pacchetti provenienti dalla seconda interfaccia(rete2)  %d\n", statistiche.receiver2);
		printf("Pacchetti destinati alla prima interfaccia(rete1)  %d\n", statistiche.sender1);
		printf("Pacchetti destinati alla seconda interfaccia(rete2)  %d\n", statistiche.sender2);
		printf("Pacchetti con destinazione non nota:  %d\n", statistiche.anonimo);
		printf("Pacchetti destinati a host della rete:\n");
		for(i=0; i < arp_n; i++){
			printf("%d.%d.%d.%d  |  %d  |  %2.3f %%", arp_t[i].ip[0], arp_t[i].ip[1], arp_t[i].ip[2], arp_t[i].ip[3], arp_t[i].cont, ((stat = arp_t[i].cont)/statistiche.receiver2)*100); 
			printf("\n-----------------------------------------------\n");
		}
		printf("Totale pachetti conteggiati nella rete di Camozzo:   %d", statistiche.totale);
		cont=300;
		printf("\nPremere un tasto per continuare!\n");
		scanf("%c", &c);
		}
	}			
}




