/* Router.c  
   programma con funzioni di router
   non ci sono code, deve eseguire tutto velocemente  */


/* include o meno dei pacchetti a seconda del compilatore  *
#include <sys/socket.h>
#include <features.h>    /* for the glibc version number */
#if __GLIBC__ >= 2 && __GLIBC_MINOR >= 1
 #include <netpacket/packet.h>
 #include <net/ethernet.h>     /* the L2 protocols */
#else
 #include <asm/types.h>
 #include <linux/if_packet.h>
 #include <linux/if_ether.h>   /* The L2 protocols */
#endif

#include <sys/types.h>
#include <sys/socket.h>
#include <string.h>


#define  ETH_SIZE  1500

struct sockaddr_ll from;  // da dove ricevo il pacchetto


struct pacc_ICMP "echo message"{
  unsigned char prot_type[2];
  unsigned char code_size[2];
  unsigned char identifier[4];
 unsigned char  seq_number[4];
 unsigned int data[4];

}  


// definisco la struct per leggere il pacchetto ARP
struct pacc_arp {
/*char           eth_destin[6] ;
  char           eth_source[6] ;
  char           fr_type[2] ; */   // parte tolta (parametro SOCK_DGRAM) 
  char           hw_type[2] ;      // short prende 2 byte  -> short <nome campo>
  char           prot_type[2] ;
  char           hw_size      ;
  char           prot_size ;
  char           op_fields[2]  ;
  unsigned char  sen_et_add[6] ;   // sono dei puntatori
  unsigned char  sen_ip_add[4] ;
  unsigned char  des_et_add[6] ;
  unsigned char  des_ip_add[4] ;
  }  *arp_pack ;  // puntatore alla struttura di nome pacc_arp



struct arp_entry {
   unsigned char  mac[6] ;
   unsigned char  ip[4]  ;
} ;

// alloco stasticamente 256 righe per la tabella
struct arp_entry arp_t[256];

int arp_n = 0; // numero di elementi presenti nella struct arp_t




/*  funzione  stampa_ARP   si implemta funzione prima di chiamarla
    ================ */

void stampa_ARP()
{
  int i;
 
  for (i=0; i<arp_n; i++)
   {
    printf("IP :%d.%d.%d.%d     MAC :%x:%x:%x:%x\n", arp_t[i].ip[0],arp_t[i].ip[1],arp_t[i].ip[2],arp_t[i].ip[3],
            arp_t[i].mac[0], arp_t[i].mac[1], arp_t[i].mac[2], arp_t[i].mac[3], arp_t[i].mac[4], arp_t[i].mac[5]);
    printf("=================\n\n");
   }

}



/*  funzione  AGGIORNA_ARP   si implemta funzione prima di chiamarla
    ================ */

int aggiorna_ARP(char *mac, char *ip)
{

 int i;

 // devo controllare se ho gi in tabella indirizzo mac passato dalla funzione
 // scorro la tabella e controllo
 for (i=0; i< arp_n; i++)
  {
     // uso funzione memcmp  resitutisce 0 m se n byte sono uguali
     if (memcmp(ip,arp_t[i].ip, 4) == 0) // sono 4 i byte da confrontare
      {  
        memcpy(arp_t[i].mac, mac, 6); // eseguo update di default dell'indirizzo MAC
        

return 1;                     // 1 per update ind. MAC
      }

  } 

   // inserisco nuovo elemento
   memcpy(arp_t[arp_n].mac, mac, 6); // eseguo update di default dell'indirizzo MAC
   memcpy(arp_t[arp_n].ip, ip, 4);   // eseguo update di default dell'indirizzo MAC
   arp_n++;                          // aggiorno arp_n
   return 0;                         // aggiunta riga nella tabella


}





/*  funzione  RIVEVI 
    ================ */

int ricevi(int s, char * buffer)
{

  // attenzione variabili gi dichiarate in MAIN

  // dichiariamo un descrittore
  int len, from_len, i, j; 
  struct arp_packet *arp_p;


  // ciclo per cattura solo pacchetti definiti A.R.P.  in frame type '0x0806'
  // devo caricare il contenuto della struttura 
  from.sll_family   = AF_PACKET;
  from.sll_protocol = htons(ETH_P_ALL);
  from.sll_ifindex  = 0;
  from.sll_hatype   = 0;  // serve per la SEND invio (tipo ARP)
  from.sll_pkttype  = 0;  // anche PACKET_BROADCAST !!
  from.sll_halen    = 0;  // filtro indirizzo MAC da cui vengono i pacchetti  
  // from.sll_addr[8]  =  // indirizzo MAC di 48 bit 

  // lunghezza della struttura -> serve alla recvfrom
  from_len = sizeof(struct sockaddr_ll);

  // inserisco i dati del frame trovato in buffer , ritorno il n. byte letti
  len = recvfrom(s, buffer, ETH_SIZE, 0, (struct sockaddr*) &from, &from_len);

  if (len == -1)
    {
     perror("receive from fallita");
     return 1;
    }


  // chiudo il while  al primo frame A.R.P. pescato dalla LAN
  if (from.sll_protocol == htons(0x0806))  /* senza htons() != 0x0608 */
    {
      arp_pack = (struct pacc_arp *) buffer ;
      if (aggiorna_ARP( (*arp_pack).sen_et_add, (*arp_pack).sen_ip_add ) == 0)  // passo MAC address e IP
       { 
        stampa_ARP();  
       }

      return 1;
    } 

  // controllo se ho un pacchetto IP   campo Type del pacchetto  
  if (from.sll_protocol == htons(0x0800))  /* senza htons() != 0x0008 */
   {
    /*printf("ho rivuto pacchetto IP\n");*/
   
    return 0;
   }



/*  for (i=0; i <= len; i++)
   {
    printf("%x ",buffer[i]);  // stampo tutto il contenuto del buffer
   }
   
  printf("\n");

  // leggo il contenuito del buffer secondo la struttura del pacchetto ARP
  arp_pack = (struct pacc_arp *) buff_in ;

  // visualizzo campo per campo
  printf("Hardware type  %x %x\n", (*arp_pack).hw_type[1], (*arp_pack).hw_type[2]);
  printf("Protocol type  %x %x\n", (*arp_pack).prot_type[1], (*arp_pack).prot_type[2]);
  printf("Hardware size  %d\n", (*arp_pack).hw_size);
  printf("Protocol size  %d\n", (*arp_pack).prot_size);
  printf("Op fields      %x %x",(*arp_pack).op_fields[1], (*arp_pack).op_fields[2]);
  printf("Source MAC Add.");  
  for (j=0; j<6 ; j++)
    printf("%x:", (*arp_pack).sen_et_add[j]);
  printf("\n");
  printf("Source IP Add. ");  
  for (j=0; j<4 ; j++)
    printf("%d:", (*arp_pack).sen_ip_add[j]);
  printf("\n");
  printf("Destin MAC Add.");  
  for (j=0; j<6 ; j++)
    printf("%x:", (*arp_pack).des_et_add[j]);
  printf("\n");
  printf("Destin IP Add. ");  
  for (j=0; j<4 ; j++)
    printf("%d:", (*arp_pack).des_ip_add[j]);
  printf("\n");

*/

 return 1;   // chiuudo funzione ricevi
}



 void stampa_ping(){
  int i;
 for(i=0;i<ping_n;i++){
  printf("echo message \n");
}
  }





 int recivi(int s, char *buffer)
{
  struct pacc_ICMP; 
 
 
 if ( prot_type = 8){
  print("echo message \n")
     perror("echo message fallita");
       return 1;
}
 if ( prot_type = 0){
   printf("echo response \n")
     perror("echo response fallita");
       return 0;
} 







/*  MAIN  PROGRAM 
   ==============  */

int main()
{


  unsigned char buffer[1500] ;    // contiene frame Ethernet  (puntatore)
  int s0;                         // descrittore del socket
  int n;


  // connessione  -> da eseguire una sola volta
  s0 = socket(PF_PACKET, SOCK_DGRAM, htons(ETH_P_ALL));
  // controllo il return value del socket
  if (s0 == -1)
    {
     perror("socket fallita");
     return 1;
    }


  while (1)  {
     
      n = ricevi(s0, buffer) ; // blocca finche non arriva il pacchetto  -> recvfrom()
                                   // devo fare una richiesta di ARP --> devo attendere
                                   // creo una coda deve memorizzare i pacchetti in arrivo

      // se non conosco ARP -> metto in coda                                        
      // se e' un frame ARP mettilo in un atableea ARP - indirizzi
      // controlla nella coda e prova il reinvio (trova ARP nella tabella)
      // uso un timer !!! 



/*
      if (n == 0)
        {
          decidi(buffer, &decisione) ; // decido sulla base del pacchetto

          invia(s0, buffer, decisione) ;  // se non ha MAC address devo inserire il pacchetto
                                          // in una coda di attesa

        }   

*/

      }  // chiudo il while


}











