/**********************************************/
/**Programma di routing---> a due reti LAN*****/
/**********************************************/

#include <netinet/in.h>
#include <sys/socket.h>
#include <features.h>    /* for the glibc version number */
#if __GLIBC__ >= 2 && __GLIBC_MINOR >= 1
#include <netpacket/packet.h>
#include <net/ethernet.h>     /* the L2 protocols */
#else
#include <asm/types.h>
#include <linux/if_packet.h>
#include <linux/if_ether.h>   /* The L2 protocols */
#endif

struct decis {						//Elemento di decisione: a)IP destinazione b)Interfaccia di rete
	unsigned int to;
	int ifn;
	};

struct route_entry					//2 rotte possibili interfaccia della I rete o II rete
	{						//Decione presa dalla subnetmask dell'IP di rete
	unsigned int dst;
	unsigned int msk;
	unsigned int nxt;
	unsigned int ifn;
	};
struct route_entry rt[2]={ {0x0001010a,0x00ffffff,0,3},
			   {0x0023a293,0x00ffffff,0,2}};
int rt_n=2;
							//IP e MAC delle reti e delle schede di rete
unsigned char mymac[2][6] = { {0x00,0x01,0x02,0x1e,0x68,0x37},{0x00,0x50,0xda,0x7c,0xbc,0xe4}};
unsigned char myip[2][4] = { { 147, 162,35,137},{10,1,1,1}};


struct arp_entry
{
	unsigned char mac[6];
	unsigned char ip[4];
	unsigned int stat;
};

struct arp_entry arp_t[256];				//Cache con IP e rispettivi MAC (da aggiornare)
int arp_n=0;

#define ETH_SIZE 1500
struct sockaddr_ll from;				//Pacchetto di ricezione qualunque esso sia
struct arp_packet{					//Formato pacchetto ARP ( associa ad IP l'ind macchima )
	short hwtype;
	short prottype;
	char hwsize;
	char protsize;
	short op;
	char sender_ha[6];
	char sender_pa[4];
	char receiver_ha[6];
	char receiver_pa[4];
	};
struct ip_packet
{
	unsigned char vi;
	unsigned char tos;
	unsigned short totl;
	unsigned short ident;
	unsigned short freg;
	unsigned char tl;
	unsigned char prot;
	unsigned short chek;
	unsigned char sadd[4];
	unsigned char dadd[4];
	unsigned int options;
	
};
struct ip_packet ipp;
struct icmp_packet
{
	char type;
	char code;
	short cheksum;
	short ident;
	short seq;
	char data[4];
};
struct icmp_packet echo, replay;

void stampa_ARP()					//Stampa un new MAC trovato non presente nella cache
{
int i;
for(i=0;i<arp_n;i++)
	printf("%d.%d.%d.%d -----> %x:%x:%x:%x:%x:%x\n",arp_t[i].ip[0],arp_t[i].ip[1],arp_t[i].ip[2],arp_t[i].ip[3],arp_t[i].mac[0],arp_t[i].mac[1],arp_t[i].mac[2],arp_t[i].mac[3],arp_t[i].mac[4],arp_t[i].mac[5]);
printf("==========\n\n");
}

int aggiorna_ARP(char* mac, char *ip)			//Aggiorna o inserisce nella cache i MAC add per ciascuno IP
{
int i;
for(i=0;i<arp_n;i++) {
	if ( memcmp(ip,arp_t[i].ip,4) == 0){ /* Se sono uguali*/
		memcpy(arp_t[i].mac,mac,6);  /* Aggiorno la entry*/
		arp_t[i].stat += 1;	     /* Incrementa l'unit statistica */
	return 1;
	}
}
memcpy(arp_t[arp_n].mac,mac,6); /* Aggiungo la entry mac*/
memcpy(arp_t[arp_n].ip,ip,4);   /* Aggiungo la entry ip*/
arp_t[arp_n].stat += 1;		/* Aggiorna l'unit statistica */
arp_n ++;
return 0;
}

int stat=0, int1;
int decidi(unsigned char * buffer, struct decis *d)	//Verifica il datagram che sia ind ad una o l'altra rete
{							//Aggiorna i campi di destinazione per ind nell'iterfaccia opportuna
int i, trovato=0;
unsigned int * dst;
dst = ((unsigned int *) buffer) + 4;
for(i=0;i<rt_n && ! trovato;i++){
	if( (*dst & rt[i].msk) == (rt[i].dst & rt[i].msk))
	{
		trovato = 1;
		if ( rt[i].nxt == 0 )
			(*d).to = *dst;
		else
			(*d).to = rt[i].nxt;
		(*d).ifn = rt[i].ifn;
		if ( i == 0 )
			stat++;
		else
			{int1++; stat++;}
	}
}
if ( trovato )
	printf("Ho deciso per %d.%d.%d.%d\n",*((unsigned char *) dst),*((unsigned char *) dst+1),*((unsigned char *)dst+2),*((unsigned char *)dst+3));
if (! trovato ){
	printf("Non so come raggiungere %d.%d.%d.%d\n",*((unsigned char *) dst),*((unsigned char *) dst+1),*((unsigned char *)dst+2),*((unsigned char *)dst+3));
	stat++;}
return trovato;
}

int ricevi(int s, char * buffer, int * lungh_pacc)	//Ricevuto un pacchetto ARP o IP lo riconosce
{							//Aggiorna la cache IP---->MAC
int i;
int s0;
int len;
int from_len;
char c;
struct arp_packet *arp_p;
from.sll_family = AF_PACKET; from.sll_protocol = htons(ETH_P_ALL); from.sll_ifindex =0; from.sll_pkttype = 0; from.sll_hatype=0; from.sll_halen=0;
from_len = sizeof(struct sockaddr_ll);

	
len = recvfrom(s,buffer,ETH_SIZE,0,(struct sockaddr*)&from,&from_len);
*lungh_pacc = len;
if ( len == -1 ){
	perror("recvfrom fallita");
	return 1;
	}
if (from.sll_protocol == htons(0x0806)){
	arp_p = (struct arp_packet *) buffer;
	if(aggiorna_ARP((*arp_p).sender_ha, (*arp_p).sender_pa) == 0)
		stampa_ARP();
	return 1;
	}

if (from.sll_protocol == htons(0x0800)){
	if(buffer[9] == 6)
		printf("\nSei un pacchetto TCP %c", buffer[9]);

	if(buffer[9] == 1 && buffer[(buffer[0]&15)*4] == 0)
	{	printf("Risposta ricevuta\n");
		return 1;
	}
/*	printf("Ho ricevuto un pacchetto IP\n"); */
	return 0;
	}

/*
for(i=0;i<len;i++){
	printf("%x ",buffer[i]);
	}
printf("\n");
*/
return 1;
}
int trova_arp(unsigned int ip, unsigned char *mac) 	//Dato un IP verifica e salva un MAC add se lo trova in cache
{
int i;
for (i=0;i<arp_n;i++){
	if ( memcmp(&ip,arp_t[i].ip,4) == 0 ){
		memcpy(mac,arp_t[i].mac,6);
		return 1;
	}
}
return 0;
}

void invia_arp(int s0, struct decis d)			//Prepara un pacchetto ARP con IP e MAC source e scatena l'inferno
{
struct sockaddr_ll to;
struct arp_packet ap;
to.sll_family = AF_PACKET;
to.sll_protocol = htons (ETH_P_ARP);
to.sll_ifindex = d.ifn;
to.sll_addr[0]=255; to.sll_addr[1]=255; to.sll_addr[2]=255; to.sll_addr[3]=255; to.sll_addr[4]=255; to.sll_addr[5]=255;
ap.hwtype = htons(1);
ap.prottype = htons (0x0800);
ap.hwsize = 6;
ap.protsize = 4;
ap.op = htons(1);
memcpy(ap.sender_ha,mymac[d.ifn-2],6);
memcpy(ap.sender_pa,myip[d.ifn-2],4);
ap.receiver_ha[0]=0; ap.receiver_ha[1]=0; ap.receiver_ha[2]=0; ap.receiver_ha[3]=0; ap.receiver_ha[4]=0; ap.receiver_ha[5]=0;
memcpy(ap.receiver_pa,&d.to,4);
if (sendto(s0,(unsigned char *)&ap,sizeof(ap),0,(struct sockaddr *)&to,sizeof(to))== -1){
	perror("Invio pacchetto ETH+ARP fallito");
	}

}

void invia(int s0, unsigned char * buffer, int pktlen, struct decis d)  //Recupera il MAC e invia il pacchetto  completo
{
struct sockaddr_ll to;
unsigned char mac[6];

 if (trova_arp(d.to,mac) == 0){
	invia_arp(s0,d);
	return ;
 }
 to.sll_family = AF_PACKET;
 to.sll_protocol=htons(ETH_P_IP);
 to.sll_halen = 6;
 to.sll_ifindex = d.ifn;
 memcpy(to.sll_addr,mac,6);
 if (sendto(s0,buffer,pktlen,0,(struct sockaddr *)&to,sizeof(to))== -1){
	perror("Invio pacchetto ETH+IP fallito");
	}
 }
unsigned short cheksum (unsigned short * seq, int lungh)
{
	int i;
	unsigned short oldcs, cs=0;
	for(i=0; i<lungh; i++)
	{	oldcs = cs;
		cs = cs + seq[i];
		if( cs < oldcs )
			cs++;
	}
	cs = 0xffff - cs;
	return cs;

}
int main()
{
unsigned char buffer[1500], msg[1500], c;
int s0;
int n, cont=100, i;
int pkt_len, len;
char * ip, * icmp;
struct decis decisione;
//inizializzazione del icmp
echo.type = 8;
echo.code = 0;
echo.cheksum = 0;
echo.ident = 10;
echo.seq = 0;
echo.data[0] = 1;echo.data[1] = 2; echo.data[2] = 3; echo.data[4] = 4;
echo.cheksum = htons(cheksum((unsigned short *)&echo.type, 16) + cheksum((unsigned short *)&echo.code, 16) + cheksum(&echo.ident, 16) + cheksum(&echo.seq, 16) + cheksum((unsigned short *)&echo.data[0], 16) + cheksum((unsigned short *)&echo.data[2], 16) );

//inizializzazione ip
ipp.vi = 69;
ipp.tos = 3;
ipp.totl = 32;
ipp.ident = 0;
ipp.freg = 16384;
ipp.tl = 255;
ipp.prot = 1;
ipp.chek = 0;
ipp.sadd[0]=147; ipp.sadd[1]=162; ipp.sadd[2]=35; ipp.sadd[3]=134;
ipp.dadd[0]=147; ipp.dadd[1]=162; ipp.dadd[2]=35; ipp.dadd[3]=137;
ipp.options = 0;
ipp.chek = htons(cheksum((unsigned short *)&ipp.vi, 16) + cheksum((unsigned short *)&ipp.tos, 16) + cheksum(&ipp.ident, 16) + cheksum(&ipp.freg, 16) + cheksum((unsigned short *)&ipp.tl, 16) + cheksum((unsigned short *)&ipp.prot, 16) + cheksum(&ipp.chek, 16) + cheksum((unsigned short *)&ipp.dadd[0] , 16)+ cheksum((unsigned short *)&ipp.dadd[2] , 16)+ cheksum((unsigned short *)&ipp.sadd[0] , 16)+ cheksum((unsigned short *)&ipp.sadd[2] , 16));

ip = (char *)&ipp;
icmp = (char *)&echo;
strcat(ip, icmp);
len = strlen( ip );
s0=socket(PF_PACKET, SOCK_DGRAM, htons(ETH_P_ALL) );  //Apertura di un PoA per la ricezione tutti i protocolli di rete
if (s0 == -1 ){
	perror("socket fallita");
	return 1;
	}
while(1)
{
	invia(s0, ip, len, decisione);
	ricevi(s0, ip, &pkt_len);
}
while( cont > 0 ) {					      	    //Riceve un pacchetto lo riconosce e aggiorna la cache
	n=ricevi(s0,buffer,&pkt_len);
	if (n == 0){				      	    //Se trattasi di un pacchetto IP:
		if (decidi(buffer, &decisione)==1)    	    //Decide l' interface di rete da indirizzarlo
			invia(s0,buffer,pkt_len,decisione); //Se l'interface e conosciuta invia il pacchetto a destination
		}
	cont--;
	if( cont == 1) {
		printf("\nStatistiche delle richieste agl'host della rete:\n");
		for(i=0; i < 256; i++){
			printf("host: %c.%c.%c.%c <=> richieste %d | rete2: richieste %d", arp_t[i].ip[0], arp_t[i].ip[1], arp_t[i].ip[2], arp_t[i].ip[3], arp_t[i].stat, int1);
			printf("\n-----------------------------------------------------\n");
		}
		cont=100;
		printf("\nPremere un tasto per continuare!\n");
		scanf("%c", &c);
		}
	}
}




