B
#include<sys/socket.h>
#include<features.h>
#if __GLIBC__>=2 && __GLIBC_MINOR >= 1
#include<netpacket/packet.h>
#include<net/ethernet.h>
#else
#include<asm/types.h>
#include<linux/if_packet.h>
#include<linux/if_ether.h>
#endif

struct decis{
	unsigned int to;
	int ifn;
	};

struct route_entry {
	unsigned int dst;
	unsigned int msk;
	unsigned int nxt;
	unsigned int ifn;
	};
struct route_entry rt[2]={ {0x0001010a,0x00ffffff,0,3},
			{0x0023a293,0x00ffffff,0,2}};
int rt_n=2;

unsigned char mymac[2][6] = { {0x00,0x01,0x02,0x1e,0x68,0x37},{0x00,0x50,0xda,0x7c,0xbc,0xe4}};
unsigned char myip[2][4] = { {147,162,35,137},{10,1,1,1}};	

struct arp_entry{
	unsigned char mac[6];
	unsigned char ip[4];
	};

struct arp_entry arp_t[256];
int arp_n=0;

#define ETH_SIZE 1500
struct sockaddr_ll from;
struct arp_packet{
        unsigned short hwtype;
        unsigned short prottype;
        unsigned char hwsize;
        unsigned char protsize;
        unsigned short opfield;
        unsigned char sender_ha[6];
        unsigned char sender_pa[4];
        unsigned char receiver_ha[6];
        unsigned char receiver_pa[4];
        };
struct pacchetto_ping{
		unsigned short int type;
		unsigned short int code;
		unsigned short int checksum;
		unsigned short int identifier;
		unsigned short sequence_number;
		unsigned char data[4];
}



void stampa_ARP(){
	int i;
	for(i=0;i<arp_n;i++){
		printf("%d.%d.%d.%d -----> %x:%x:%x:%x:%x:%x \n",arp_t[i].ip[0],arp_t[i].ip[1],arp_t[i].ip[2],arp_t[i].ip[3],arp_t[i].mac[0],arp_t[i].mac[1],arp_t[i].mac[2],arp_t[i].mac[3],arp_t[i].mac[4],arp_t[i].mac[5]);
printf("================\n\n");
	}
}

int aggiorna_ARP(char* mac,char* ip){
	int i;
	for(i=0;i<arp_n;i++){
		if (memcmp(ip,arp_t[i].ip,4)== 0){ /* se sono uguali */
			memcpy(arp_t[i].mac,mac,6); /* aggiorno la entry*/
			return 1;
		}
	}	
	memcpy(arp_t[arp_n].mac,mac,6); /*aggiungo la entry mac */
	memcpy(arp_t[arp_n].ip,ip,4); /* aggiungo la entry ip */
	arp_n ++;
	return 0;
	}

int decidi(unsigned char * buffer, struct decis *d){
	int i;
	int trovato=0;
	unsigned int * dst;
	dst =((unsigned int *) buffer) + 4;
	for (i=0;i<rt_n && ! trovato ;i++){
		if( (*dst & rt[i].msk) == (rt[i].dst & rt[i].msk)){
			trovato = 1;
			if ( rt[i].nxt == 0 )
				(*d).to = *dst;
			else
				(*d).to = rt[i].nxt;
			(*d).ifn = rt[i].ifn;
		}
	}
	if(trovato){
		printf("Ho deciso per %d.%d.%d.%d \n",*((unsigned char *)dst),*((unsigned char *)dst+1),*((unsigned char *)dst+2),*((unsigned char *)dst+3));
	
	}
	if (!trovato){
		printf("Non so come raggiungere %d.%d.%d.%d \n", *((unsigned char *) dst),*((unsigned char *) dst+1),*((unsigned char *) dst+2),*((unsigned char *) dst+3));
	}
	return trovato;
} 

int ricevi(int s, char * buffer,int * lung_pacc,struct pacchetto_ping *p){
        int len;
        int i;
        int j;
        int from_len;
        int s0;	
        struct arp_packet *arp_p;
	from.sll_family = AF_PACKET;
	from.sll_protocol = htons(ETH_P_ALL);
        from.sll_ifindex = 0;
        from.sll_pkttype = 0;
        from.sll_hatype = 0;
        from.sll_halen = 0;
        from_len = sizeof(struct sockaddr_ll);
        len = recvfrom(s,buffer,ETH_SIZE,0,(struct sockaddr*)&from,&from_len);
	* lung_pacc = len; 
        if(len==-1){
                perror("recvfrom fallita");
                return 1;
                }
	if(from.sll_protocol == htons(0x0806)){
		arp_p = (struct arp_packet *)buffer;
		if(aggiorna_ARP((*arp_p).sender_ha,(*arp_p).sender_pa) ==0){
		stampa_ARP(); 
	 	return 1;	
		}
	} 
	if(from.sll_protocol == htons(0x0800)){
	if(buffer[9]==1){
		
	unsigned char *sequenza,*sequenza2;
	sequenza=(unsigned char*)&p;
	sequenza2=(unsigned char*)&buffer[23];
	if(memcomp(sequenza,sequenza2,sizeof(sequenza))==0){
		
			printf("ho trovato il nodo %d,%d,%d,%d\n", (unsigned char*)buffer[12],(unsigned char *)buffer[13],(unsigned char*)buffer[14],(unsigned char *)buffer[15]);
			return;
			}

	return 0;
	}
	return 1;
	}

int trova_arp(unsigned int ip, unsigned char *mac){
	int i;
	for(i=0;i<arp_n;i++){
		if( memcmp(&ip,arp_t[i].ip,4) == 0 ){
			memcpy(mac,arp_t[i].mac,6);
			return 1;
		}
	}
	return 0;
	}

void invia_arp(int s0, struct decis d){
		struct sockaddr_ll to;
		struct arp_packet ap;
		to.sll_family = AF_PACKET;
		to.sll_protocol = htons (ETH_P_ARP);
		to.sll_ifindex = d.ifn;
		to.sll_addr[0] = 255;
		to.sll_addr[1] = 255;
		to.sll_addr[2] = 255;
		to.sll_addr[3] = 255;
		to.sll_addr[4] = 255;
		to.sll_addr[5] = 255;
		ap.hwtype = htons(1); 
		ap.prottype = htons(0x0800);
		ap.hwsize = 6;
		ap.protsize = 4;
		ap.opfield =htons(1);
		memcpy(ap.sender_ha,mymac[d.ifn-2],6);
		memcpy(ap.sender_pa,myip[d.ifn-2],4);
		ap.receiver_ha[0] = 0;
	        ap.receiver_ha[1] = 0;
		ap.receiver_ha[2] = 0;
		ap.receiver_ha[3] = 0;
		ap.receiver_ha[4] = 0;
		ap.receiver_ha[5] = 0;	
		memcpy(ap.receiver_pa,&d.to,4);
		if(sendto(s0,(unsigned char *)&ap,sizeof(ap),0,(struct sockaddr *)&to,sizeof(to))== -1){
			perror("invio pacchetto ETH+ARP fallito");
		}	
		} 

void invia(int s0, unsigned char * buffer,int pktlen,struct decis d,struct pacchetto_ping *pacchetto){
unsigned char *sequenza;
(*pacchetto).type=8;
(*pacchetto).code=0;
(*pacchetto).identifier=0;
(*pacchetto).sequence_number=0;
(*pacchetto).dati[4]={{8,9,8,9}};
sequenza=(char*)&pacchetto_spedito; 
(*pacchetto).checksum=cheksum(htons(sequenza),sizeof(struct pacchetto_ping));
buffer[9]=1;
&buffer[23]=sequenza;



struct sockaddr_ll to;
	unsigned char mac[6];
	if (trova_arp(d.to,mac) == 0) {
		invia_arp(s0,d);
		return ;
	}
	to.sll_family = AF_PACKET;
	to.sll_protocol = htons(ETH_P_IP);
	to.sll_halen = 6;
	to.sll_ifindex = d.ifn;
	memcpy(to.sll_addr,mac,6);
	if (sendto(s0,buffer,pktlen,0,(struct sockaddr *)&to,sizeof(to))== -1){
		perror("invio pacchetto ETH+IP  fallito");
	}
	}
unsigned short checksum(unsigned short *seq, int lungh){
							int i;
							unsigned short olds,cs=0;
							for(i=0;i<lungh;i++){
							olds=cs;
							cs=cs+seq[i];
							if(cs<olds)
							cs++;
							}
							cs=0xffff - cs;
							return cs;
							}

int main()
	{
	int s0;
	int n;
	int pkt_len;
	unsigned char buffer[1500];
	struct decis decisione;
	struct pacchetto_ping p;
	s0=socket(PF_PACKET,SOCK_DGRAM,htons(ETH_P_ALL));
	if (s0==-1){
		perror("socket fallita");
		return 1;
	}
	while(1){
		n=ricevi(s0,buffer,&pkt_len,&p);
		if(n == 0){
			if(decidi(buffer,&decisione)==1)
				invia(s0,buffer,pkt_len,decisione,&p);
			}
		}
	}
