#include <sys/socket.h>
#include <features.h>		/* for the glibc version number */
#if __GLIBC__ >= 2 && __GLIBC_MINOR >= 1
#include <netpacket/packet.h>
#include <net/ethernet.h>	/* the L2 protocols */
#else /*  */
#include <asm/types.h>
#include <linux/if_packet.h>
#include <linux/if_ether.h>	/* The L2 protocols */
#endif /*  */
struct decis
{
  unsigned int to;
  int ifn;
};
struct route_entry
{
  unsigned int dst;
  unsigned int msk;
  unsigned int nxt;
  unsigned int ifn;
};

struct route_entry rt[2]={ {0x0001010a,0x00ffffff,0,2}, 
			   {0x0023a293,0x00ffffff,0,3}};
int rt_n=2;
	
unsigned char mymac[2][6] = { {0x00,0xa0,0x24,0x82,0xff,0x1e},{0x00,0x50,0x04,0x01,0xd6,0x56}};
unsigned char myip[2][4] = { { 147, 162,35,66},{10,1,1,1}};



struct arp_entry
{
  unsigned char mac[6];
  unsigned char ip[4];
};
struct arp_entry arp_t[256];
int arp_n = 0;

#define ETH_SIZE 1500
struct sockaddr_ll from;
struct arp_packet
{
  short hwtype;
  short prottype;
  char hwsize;
  char protsize;
  short op;
  char sender_ha[6];
  char sender_pa[4];
  char receiver_ha[6];
  char receiver_pa[4];
};
void
stampa_ARP ()
{
  int i;
  for (i = 0; i < arp_n; i++)
    printf ("%d.%d.%d.%d -----> %x:%x:%x:%x:%x:%x\n", arp_t[i].ip[0],
	    arp_t[i].ip[1], arp_t[i].ip[2], arp_t[i].ip[3], arp_t[i].mac[0],
	    arp_t[i].mac[1], arp_t[i].mac[2], arp_t[i].mac[3],
	    arp_t[i].mac[4], arp_t[i].mac[5]);
  printf ("==========\n\n");
}

int
aggiorna_ARP (char *mac, char *ip)
{
  int i;
  for (i = 0; i < arp_n; i++)
    {
      if (memcmp (ip, arp_t[i].ip, 4) == 0)
	{			/* Se sono uguali */
	  memcpy (arp_t[i].mac, mac, 6);	/* Aggiorno la entry */
	  return 1;
	}
    }
  memcpy (arp_t[arp_n].mac, mac, 6);	/* Aggiungo la entry mac */
  memcpy (arp_t[arp_n].ip, ip, 4);	/* Aggiungo la entry ip */
  arp_n++;
  return 0;
}

int
decidi (unsigned char *buffer, struct decis *d)
{
  int i, trovato = 0;
  unsigned int *dst;
  dst = ((unsigned int *) buffer) + 4;
  for (i = 0; i < rt_n && !trovato; i++)
    {
      if ((*dst & rt[i].msk) == (rt[i].dst & rt[i].msk))
	{
	  trovato = 1;
	  if (rt[i].nxt == 0)
	    (*d).to = *dst;
	  else
	    (*d).to = rt[i].nxt;
	  (*d).ifn = rt[i].ifn;
	}
    }
  if (trovato)
    printf ("Sto routando  %d.%d.%d.%d \n",
	    *((unsigned char *) dst), *((unsigned char *) dst + 1),
	    *((unsigned char *) dst + 2), *((unsigned char *) dst + 3));
  if (!trovato)
    printf ("Non so come raggiungere %d.%d.%d.%d\n",
	    *((unsigned char *) dst), *((unsigned char *) dst + 1),
	    *((unsigned char *) dst + 2), *((unsigned char *) dst + 3));
return trovato;
}

int
ricevi (int s, char *buffer, int *lungh_pacc)
{
  int i;
  int s0;
  int len;
  int from_len;
  struct arp_packet *arp_p;
  from.sll_family = AF_PACKET;
  from.sll_protocol = htons (ETH_P_ALL);
  from.sll_ifindex = 0;
  from.sll_pkttype = 0;
  from.sll_hatype = 0;
  from.sll_halen = 0;
  from_len = sizeof (struct sockaddr_ll);
  len =
    recvfrom (s, buffer, ETH_SIZE, 0, (struct sockaddr *) &from, &from_len);
  *lungh_pacc = len;
  if (len == -1)
    {
      perror ("recvfrom fallita");
      return 1;
    }
  if (from.sll_protocol == htons (0x0806))
    {
      arp_p = (struct arp_packet *) buffer;
      if (aggiorna_ARP ((*arp_p).sender_ha, (*arp_p).sender_pa) == 0) 
	stampa_ARP ();
      return 1;
    }
  if (from.sll_protocol == htons (0x0800))
    {

/* printf("Ho ricevuto un pacchetto IP\n"); */
      return 0;
    }

/*
for(i=0;i<len;i++){
printf("%x ",buffer[i]);
}
printf("\n");
*/
  return 1;
}

int
trova_arp (unsigned int ip, unsigned char *mac)
{
  int i;
  for (i = 0; i < arp_n; i++)
    {
      if (memcmp (&ip, arp_t[i].ip, 4) == 0)
	{
	  memcpy (mac, arp_t[i].mac, 6);
	  return 1;
	}
     }
  return 0;
}

void
invia_arp (int s0, struct decis d)
{
  struct sockaddr_ll to;
  struct arp_packet ap;
  to.sll_family = AF_PACKET;
  to.sll_protocol = htons (ETH_P_ARP);
  to.sll_ifindex = d.ifn;
  to.sll_addr[0] = 255;
  to.sll_addr[1] = 255;
  to.sll_addr[2] = 255;
  to.sll_addr[3] = 255;
  to.sll_addr[4] = 255;
  to.sll_addr[5] = 255;
  ap.hwtype = htons (1);
  ap.prottype = htons (0x0800);
  ap.hwsize = 6;
  ap.protsize = 4;
  ap.op = htons(1);
  memcpy (ap.sender_ha, mymac[d.ifn - 2], 6);
  memcpy (ap.sender_pa, myip[d.ifn - 2], 4);
  ap.receiver_ha[0] = 0;
  ap.receiver_ha[1] = 0;
  ap.receiver_ha[2] = 0;
  ap.receiver_ha[3] = 0;
  ap.receiver_ha[4] = 0;
  ap.receiver_ha[5] = 0;
  memcpy (ap.receiver_pa, &(d.to), 4);
  if (sendto
      (s0, (unsigned char *) &ap, sizeof (ap), 0, (struct sockaddr *) &to,
       sizeof (to)) == -1)
    {
      perror ("Invio pacchetto ETH+ARP fallito");
    }
}
int
invia (int s0, unsigned char *buffer, int pktlen, struct decis d)
{
  struct sockaddr_ll to;
  unsigned char mac[6];
  if (trova_arp (d.to, mac) == 0)
    {
      invia_arp (s0, d);
      printf("Couldn't resolve ARP....\n");
      return 0;
    }
  to.sll_family = AF_PACKET;
  to.sll_protocol = htons (ETH_P_IP);
  to.sll_halen = 6;
  to.sll_ifindex =d.ifn;
  memcpy (to.sll_addr, mac, 6);
  if (sendto (s0, buffer, pktlen, 0, (struct sockaddr *) &to, sizeof (to)) ==
      -1)
    {
      perror ("Invio pacchetto ETH+IP fallito");
    }
  return 1;
}

int
main ()
{
  unsigned char buffer[1500];
  int s0;
  int n;
  int pkt_len;
  struct decis decisione;
  s0 = socket (PF_PACKET, SOCK_DGRAM, htons (ETH_P_ALL));
  if (s0 == -1)
    {
      perror ("socket fallita");
      return 1;
    }
  while (1)
    {
      n = ricevi (s0, buffer, &pkt_len);
      if (n == 0)
	{
	  if( decidi (buffer, &decisione))
	  	invia (s0, buffer, pkt_len, decisione);
	}
    }
}
