#include <sys/socket.h>
#include <features.h>    /* for the glibc version number */
#if __GLIBC__ >= 2 && __GLIBC_MINOR >= 1
#include <netpacket/packet.h>
#include <net/ethernet.h>     /* the L2 protocols */
#else
#include <asm/types.h>
#include <linux/if_packet.h>
#include <linux/if_ether.h>   /* The L2 protocols */
#include <linux/if_arp.h>   /* The L2 protocols */
#endif

struct sockaddr_ll from;
unsigned char buffer[1500];
struct arp_packet{
	unsigned short hwtype;
	unsigned short prottype;
	unsigned char hwsize;
	unsigned char protsize;
	unsigned short op;
	unsigned char sender_ha[6];
	unsigned char sender_pa[4];
	unsigned char receiver_ha[6];
	unsigned char receiver_pa[4];
};

struct arp_packet * arp_p;

int main()
{
int i;
int s;
int len;
int from_len;

s = socket (PF_PACKET, SOCK_DGRAM, htons(ETH_P_ALL));
if ( s == -1 ){
	perror("Socket fallita");
	return 1;
}
while( from.sll_protocol!= 0x0608 ){ /* Fino a che non abbiamo preso un ARP htons(0x0806) oppure htons(ETH_P_ARP); */
from.sll_family = AF_PACKET;
from.sll_protocol = htons(ETH_P_ALL);
from.sll_ifindex = 0;
from.sll_hatype = ARPHRD_ETHER;
from.sll_pkttype = PACKET_HOST;
from.sll_halen = 0;
from_len = sizeof(struct sockaddr_ll);
len = recvfrom (s,buffer,1500, 0, (struct sockaddr*)&from,&from_len );
if (len == -1){
	perror ("recvfrom fallita");
	return 1;
	}
}
for (i=0;i<len; i++){
	printf("%x(%d) ",buffer[i],buffer[i]);
	}
printf("\n");
arp_p = (struct arp_packet *) buffer;
printf("Tipo operazione %d\n",htons((*arp_p).op));
printf("IP sorgente: %d.%d.%d.%d\n", (*arp_p).sender_pa[0],(*arp_p).sender_pa[1],(*arp_p).sender_pa[2],(*arp_p).sender_pa[3]);
printf("IP destinazione : %d.%d.%d.%d\n", (*arp_p).receiver_pa[0],(*arp_p).receiver_pa[1],(*arp_p).receiver_pa[2],(*arp_p).receiver_pa[3]);

return 0;
}


