#include <sys/socket.h>
#include <features.h>    /* for the glibc version number */
#if __GLIBC__ >= 2 && __GLIBC_MINOR >= 1
#include <netpacket/packet.h>
#include <net/ethernet.h>     /* the L2 protocols */
#else
#include <asm/types.h>
#include <linux/if_packet.h>
#include <linux/if_ether.h>   /* The L2 protocols */
#include <linux/if_arp.h>   /* The L2 protocols */
#endif

#define TIPO_ARP 0x0608 
#define TIPO_IP  0x0008
struct route_entry{
	unsigned int dst;
	unsigned int mask;
	unsigned int nxtip;
	unsigned int ifn;
};
struct route_entry  rt[10];  
int rt_n;

void init_rt()
{
((unsigned char *)(&rt[0].dst))[0] = 147;
((unsigned char *)(&rt[0].dst))[1] = 162;
((unsigned char *)(&rt[0].dst))[2] = 35;
((unsigned char *)(&rt[0].dst))[3] = 0;
rt[0].mask = htonl(0xffffff00);             /* maschera 255.255.255.0 */
rt[0].nxtip = 0; /* Quello che sta scritto nel pacchetto*/
rt[0].ifn = 2;

((unsigned char *)(&rt[1].dst))[0] = 10;
((unsigned char *)(&rt[1].dst))[1] = 1;
((unsigned char *)(&rt[1].dst))[2] = 1;
((unsigned char *)(&rt[1].dst))[3] = 0;
rt[1].mask = htonl(0xffffff00);             /* maschera 255.255.255.0 */
rt[1].nxtip = 0; /* Quello che sta scritto nel pacchetto*/
rt[1].ifn = 3;

rt[2].dst = 0;		 /* default */
rt[2].mask = 0;           /* maschera 0.0.0.0.0 */
((unsigned char *)(&rt[2].nxtip))[0] = 147;
((unsigned char *)(&rt[2].nxtip))[1] = 162;
((unsigned char *)(&rt[2].nxtip))[2] = 35;
((unsigned char *)(&rt[2].nxtip))[3] = 254;
rt[2].ifn = 2;

rt_n =3;
}

struct arp_packet{
	unsigned short hwtype;
	unsigned short prottype;
	unsigned char hwsize;
	unsigned char protsize;
	unsigned short op;
	unsigned char sender_ha[6];
	unsigned char sender_pa[4];
	unsigned char receiver_ha[6];
	unsigned char receiver_pa[4];
};

struct arp_table {
		 unsigned char ip[4];
		 unsigned char mac[6];
		};
struct arp_table at[1000];
int at_n=0;

struct arp_packet * arp_p;

int ricevi(int s, unsigned char * buffer, unsigned short * tipo);
void stampa_arp(unsigned char * buffer, int len);
void inserisci_arp(unsigned char * ip, unsigned char * mac);
int  cerca_mac(unsigned char * ip, unsigned char *mac );
int elabora_arp(struct arp_packet * ap, unsigned char * *ip, unsigned char ** mac );
void stampa_at();

int main()
{
unsigned short tipo;
int s;
int lungh;
unsigned char * mac;
unsigned char * ip;
unsigned int nxtip;
int interface;
unsigned char nextmac[6];
unsigned char buffer[1500];
init_rt();
s = socket (PF_PACKET, SOCK_DGRAM, htons(ETH_P_ALL));
if ( s == -1 ){
	perror("Socket fallita");
	return 1;
	}
while ( 1 ){ /* Sempre*/
	lungh  = ricevi(s,buffer,&tipo);
	if (tipo == TIPO_IP){
		if (decidi(buffer,&interface,&nxtip)==0){
			if (cerca_mac((unsigned char *)&nxtip,nxtmac)==0)
				invia_arp(s,nxtip,interface);
			else
				inoltra(s,interface,nxtmac);
		}
	}
	if (tipo == TIPO_ARP ){
		if (elabora_arp((struct arp_packet *)buffer,&ip,&mac)==1){ 
			if (cerca_mac(ip,mac)==0)
				inserisci_arp(ip,mac);
		stampa_at();
		}			
	}
}
}

int ricevi(int s, unsigned char * buffer, unsigned short * tipo)
{
int len;
int from_len;
struct sockaddr_ll from;
from.sll_family = AF_PACKET;
from.sll_protocol = htons(ETH_P_ALL);
from.sll_ifindex = 0;
from.sll_hatype = ARPHRD_ETHER;
from.sll_pkttype = PACKET_HOST;
from.sll_halen = 0;
from_len = sizeof(struct sockaddr_ll);
len = recvfrom (s,buffer,1500, 0, (struct sockaddr*)&from,&from_len );
if (len == -1){
	perror ("recvfrom fallita");
	exit(1);
	}
*tipo  = from.sll_protocol;
return len;
}


void stampa_arp(unsigned char * buffer, int len)
{
int i;
for (i=0;i<len; i++){
	printf("%x(%d) ",buffer[i],buffer[i]);
	}
	printf("\n");
arp_p = (struct arp_packet *) buffer;
printf("Tipo operazione %d\n",htons((*arp_p).op));
printf("IP sorgente: %d.%d.%d.%d\n", (*arp_p).sender_pa[0],(*arp_p).sender_pa[1],(*arp_p).sender_pa[2],(*arp_p).sender_pa[3]);
printf("IP destinazione : %d.%d.%d.%d\n", (*arp_p).receiver_pa[0],(*arp_p).receiver_pa[1],(*arp_p).receiver_pa[2],(*arp_p).receiver_pa[3]);
}
 
void inserisci_arp(unsigned char * ip, unsigned char * mac)
{
	int i;
	for(i=0; i<4; i++){ /*copio 4 bytes...*/
		at[at_n].ip[i] = ip[i];
	}
	for(i=0; i<6; i++){ /*copio 6 bytes...*/
		at[at_n].mac[i] = mac[i];
	}
	at_n++ ;
}

int  cerca_mac(unsigned char * ip, unsigned char *mac  )
{
int i,j;
for (i = 0; i< at_n ; i++){
	if(*((unsigned long *)ip) == *((unsigned long*)(at[i].ip))){
		for(j=0; j<6; j++){ /*copio 6 bytes...*/
			mac[j]=at[i].mac[j];
		}
		return 1;
	}
}
return 0;
}

int elabora_arp(struct arp_packet * ap, unsigned char * *ip, unsigned char ** mac )
{
	if ( ( ap->sender_pa[0] || ap->sender_pa[1] ||
	     ap->sender_pa[2] || ap->sender_pa[3]) !=0 )
		{
		  *ip = ap->sender_pa;
		  *mac = ap->sender_ha;
		  return 1;
		}

	if ( ( ap->receiver_pa[0] || ap->receiver_pa[1] ||
	     ap->receiver_pa[2] || ap->receiver_pa[3]) !=0 )
		{
		  *ip = ap->receiver_pa;
		  *mac = ap->receiver_ha;
		  return 1;
		}
return 0;
}

void stampa_at()
{
	int i;
	printf("==========\n");
	for (i=0;i<at_n; i++){
		printf("%d) %d.%d.%d.%d --> ",i,at[i].ip[0],at[i].ip[1],at[i].ip[2],at[i].ip[3]);
		printf("%x:%x:%x:%x:%x:%x\n",at[i].mac[0],at[i].mac[1],at[i].mac[2],at[i].mac[3],at[i].mac[4],at[i].mac[5]);
	}
	printf("==========\n\n\n");
}


int decidi(unsigned char* b, int * ifn, unsigned int *  nxtip)
{
unsigned int * dst;
int i;
int trovato = 0;
dst = (unsigned int *)b + 4; 
dst = &(((unsigned int *)b)[4]);
for ( i = 0; i < rt_n && trovato==0; i++) {
	if (*dst & rt[i].mask == rt[i].dst & rt[i].mask) {
		trovato = 1;
		* ifn = rt[i].ifn;
		* nxtip = rt[i].nxtip;
		if (*nxtip == 0 )
			*nxtip = * dst;
	}
}
if (trovato==0){
	return 1; /*Errore*/
	}
return 0;
}

void invia_arp(int s, unsigned char * ip, int ifn)
{
struct sockaddr_ll to;
struct arp_packet ap;
to.sll_family = AF_PACKET;
to.sll_protocol = TIPO_ARP
to.sll_ifindex = ifn;
to.sll_hatype = ARPHRD_ETHER;
to.sll_addr[0] = to.sll_addr[1] = to.sll_addr[2] =255;
to.sll_addr[3] = to.sll_addr[4] = to.sll_addr[5]= 255;
to.halen = 6;

sendto(s,...., &to,sizeof(struct sockaddr_ll));

ap.hwtype = 1;
ap.prottype = TIPO_IP;
ap.hwsize=6;
ap.protsize=4;
ap.op = htons(1);
ap.sender_ha[0]=0; arp.sender_ha[1]=0; arp.sender_ha[2]=0;
ap.sender_ha[3]=0; arp.sender_ha[4]=0; arp.sender_ha[5]=0;
unsigned char sender_pa[4];
	unsigned char receiver_ha[6];
	unsigned char receiver_pa[4];




}

